
_set_up:

;TEA5767.c,35 :: 		void set_up() {
;TEA5767.c,37 :: 		DDC4_bit=0;   //SDA
	PUSH       R2
	PUSH       R3
	PUSH       R4
	PUSH       R5
	IN         R27, DDC4_bit+0
	CBR        R27, BitMask(DDC4_bit+0)
	OUT        DDC4_bit+0, R27
;TEA5767.c,38 :: 		DDC5_bit=0;   //SDL
	IN         R27, DDC5_bit+0
	CBR        R27, BitMask(DDC5_bit+0)
	OUT        DDC5_bit+0, R27
;TEA5767.c,39 :: 		DDB0_bit=0;
	IN         R27, DDB0_bit+0
	CBR        R27, BitMask(DDB0_bit+0)
	OUT        DDB0_bit+0, R27
;TEA5767.c,40 :: 		DDB1_bit=0;
	IN         R27, DDB1_bit+0
	CBR        R27, BitMask(DDB1_bit+0)
	OUT        DDB1_bit+0, R27
;TEA5767.c,41 :: 		TWI_Init(100000);         // initialize TWI communication
	LDS        R27, TWPS0_bit+0
	CBR        R27, BitMask(TWPS0_bit+0)
	STS        TWPS0_bit+0, R27
	LDS        R27, TWPS1_bit+0
	CBR        R27, BitMask(TWPS1_bit+0)
	STS        TWPS1_bit+0, R27
	LDI        R27, 72
	STS        TWBR+0, R27
	CALL       _TWI_Init+0
;TEA5767.c,42 :: 		Delay_ms(200);
	LDI        R18, 17
	LDI        R17, 60
	LDI        R16, 204
L_set_up0:
	DEC        R16
	BRNE       L_set_up0
	DEC        R17
	BRNE       L_set_up0
	DEC        R18
	BRNE       L_set_up0
;TEA5767.c,43 :: 		Lcd_Init();
	CALL       _Lcd_Init+0
;TEA5767.c,44 :: 		Lcd_Cmd(_LCD_CLEAR);
	LDI        R27, 1
	MOV        R2, R27
	CALL       _Lcd_Cmd+0
;TEA5767.c,45 :: 		Lcd_Cmd(_LCD_CURSOR_OFF);
	LDI        R27, 12
	MOV        R2, R27
	CALL       _Lcd_Cmd+0
;TEA5767.c,46 :: 		Lcd_Out(1, 2, "RADIO_FM");
	LDI        R27, #lo_addr(?lstr1_TEA5767+0)
	MOV        R4, R27
	LDI        R27, hi_addr(?lstr1_TEA5767+0)
	MOV        R5, R27
	LDI        R27, 2
	MOV        R3, R27
	LDI        R27, 1
	MOV        R2, R27
	CALL       _Lcd_Out+0
;TEA5767.c,47 :: 		Lcd_Out(2, 10, "MHZ");
	LDI        R27, #lo_addr(?lstr2_TEA5767+0)
	MOV        R4, R27
	LDI        R27, hi_addr(?lstr2_TEA5767+0)
	MOV        R5, R27
	LDI        R27, 10
	MOV        R3, R27
	LDI        R27, 2
	MOV        R2, R27
	CALL       _Lcd_Out+0
;TEA5767.c,48 :: 		Delay_ms(10);
	LDI        R17, 208
	LDI        R16, 202
L_set_up2:
	DEC        R16
	BRNE       L_set_up2
	DEC        R17
	BRNE       L_set_up2
	NOP
;TEA5767.c,50 :: 		}
L_end_set_up:
	POP        R5
	POP        R4
	POP        R3
	POP        R2
	RET
; end of _set_up

_Write_Frequency:
	PUSH       R28
	PUSH       R29
	IN         R28, SPL+0
	IN         R29, SPL+1
	SBIW       R28, 2
	OUT        SPL+0, R28
	OUT        SPL+1, R29
	ADIW       R28, 1

;TEA5767.c,52 :: 		void Write_Frequency(double frequency)
;TEA5767.c,54 :: 		unsigned char frequencyH=0;
	PUSH       R2
	PUSH       R3
	PUSH       R4
	PUSH       R5
;TEA5767.c,55 :: 		unsigned char frequencyL=0;
;TEA5767.c,58 :: 		frequencyB=4*(frequency*1000000+225000)/32768;
	MOVW       R16, R2
	MOVW       R18, R4
	LDI        R20, 0
	LDI        R21, 36
	LDI        R22, 116
	LDI        R23, 73
	CALL       _float_fpmul1+0
	LDI        R20, 0
	LDI        R21, 186
	LDI        R22, 91
	LDI        R23, 72
	CALL       _float_fpadd1+0
	LDI        R20, 0
	LDI        R21, 0
	LDI        R22, 128
	LDI        R23, 64
	CALL       _float_fpmul1+0
	LDI        R20, 0
	LDI        R21, 0
	LDI        R22, 0
	LDI        R23, 71
	CALL       _float_fpdiv1+0
	CALL       _float_fpint+0
;TEA5767.c,59 :: 		frequencyH=frequencyB>>8;
	MOV        R18, R17
	LDI        R19, 0
	STD        Y+0, R18
;TEA5767.c,60 :: 		frequencyL=frequencyB&0XFF;
	ANDI       R16, 255
	STD        Y+1, R16
;TEA5767.c,62 :: 		TWI_Start();
	CALL       _TWI_Start+0
;TEA5767.c,63 :: 		TWI_Write(TEA5767_W);
	LDI        R27, 192
	MOV        R2, R27
	CALL       _TWI_Write+0
;TEA5767.c,64 :: 		TWI_Write(frequencyH);
	LDD        R2, Y+0
	CALL       _TWI_Write+0
;TEA5767.c,65 :: 		TWI_Write(frequencyL);
	LDD        R2, Y+1
	CALL       _TWI_Write+0
;TEA5767.c,66 :: 		TWI_Write(0xB0);
	LDI        R27, 176
	MOV        R2, R27
	CALL       _TWI_Write+0
;TEA5767.c,67 :: 		TWI_Write(0x10);
	LDI        R27, 16
	MOV        R2, R27
	CALL       _TWI_Write+0
;TEA5767.c,68 :: 		TWI_Write(0x00);
	CLR        R2
	CALL       _TWI_Write+0
;TEA5767.c,69 :: 		TWI_Stop();
	CALL       _TWI_Stop+0
;TEA5767.c,70 :: 		Delay_ms(10);
	LDI        R17, 208
	LDI        R16, 202
L_Write_Frequency4:
	DEC        R16
	BRNE       L_Write_Frequency4
	DEC        R17
	BRNE       L_Write_Frequency4
	NOP
;TEA5767.c,71 :: 		}
L_end_Write_Frequency:
	POP        R5
	POP        R4
	POP        R3
	POP        R2
	ADIW       R28, 1
	OUT        SPL+0, R28
	OUT        SPL+1, R29
	POP        R29
	POP        R28
	RET
; end of _Write_Frequency

_Print_FM:

;TEA5767.c,72 :: 		void Print_FM(long FM) {
;TEA5767.c,76 :: 		if(FM<1000) {
	PUSH       R2
	PUSH       R3
	PUSH       R4
	PUSH       R5
	LDI        R16, 232
	LDI        R17, 3
	LDI        R18, 0
	LDI        R19, 0
	CP         R2, R16
	CPC        R3, R17
	CPC        R4, R18
	CPC        R5, R19
	BRLT       L__Print_FM34
	JMP        L_Print_FM6
L__Print_FM34:
;TEA5767.c,77 :: 		Lcd_Chr(2,4,' ');
	PUSH       R5
	PUSH       R4
	PUSH       R3
	PUSH       R2
	LDI        R27, 32
	MOV        R4, R27
	LDI        R27, 4
	MOV        R3, R27
	LDI        R27, 2
	MOV        R2, R27
	CALL       _Lcd_Chr+0
	POP        R2
	POP        R3
	POP        R4
	POP        R5
;TEA5767.c,78 :: 		ch = (FM / 100 )% 10;
	PUSH       R5
	PUSH       R4
	PUSH       R3
	PUSH       R2
	LDI        R20, 100
	LDI        R21, 0
	LDI        R22, 0
	LDI        R23, 0
	MOVW       R16, R2
	MOVW       R18, R4
	CALL       _Div_32x32_S+0
	MOVW       R16, R18
	MOVW       R18, R20
	LDI        R20, 10
	LDI        R21, 0
	LDI        R22, 0
	LDI        R23, 0
	CALL       _Div_32x32_S+0
	MOVW       R16, R22
	MOVW       R18, R24
;TEA5767.c,79 :: 		Lcd_Chr_CP(48+ch);
	SUBI       R16, 208
	MOV        R2, R16
	CALL       _Lcd_Chr_CP+0
	POP        R2
	POP        R3
	POP        R4
	POP        R5
;TEA5767.c,80 :: 		ch = (FM /10)% 10;
	PUSH       R5
	PUSH       R4
	PUSH       R3
	PUSH       R2
	LDI        R20, 10
	LDI        R21, 0
	LDI        R22, 0
	LDI        R23, 0
	MOVW       R16, R2
	MOVW       R18, R4
	CALL       _Div_32x32_S+0
	MOVW       R16, R18
	MOVW       R18, R20
	LDI        R20, 10
	LDI        R21, 0
	LDI        R22, 0
	LDI        R23, 0
	CALL       _Div_32x32_S+0
	MOVW       R16, R22
	MOVW       R18, R24
;TEA5767.c,81 :: 		Lcd_Chr_CP(48+ch);
	SUBI       R16, 208
	MOV        R2, R16
	CALL       _Lcd_Chr_CP+0
;TEA5767.c,82 :: 		Lcd_Chr(2,7,'.');
	LDI        R27, 46
	MOV        R4, R27
	LDI        R27, 7
	MOV        R3, R27
	LDI        R27, 2
	MOV        R2, R27
	CALL       _Lcd_Chr+0
	POP        R2
	POP        R3
	POP        R4
	POP        R5
;TEA5767.c,83 :: 		ch = FM % 10;
	LDI        R20, 10
	LDI        R21, 0
	LDI        R22, 0
	LDI        R23, 0
	MOVW       R16, R2
	MOVW       R18, R4
	CALL       _Div_32x32_S+0
	MOVW       R16, R22
	MOVW       R18, R24
;TEA5767.c,84 :: 		Lcd_Chr(2,8,48+ch);
	SUBI       R16, 208
	MOV        R4, R16
	LDI        R27, 8
	MOV        R3, R27
	LDI        R27, 2
	MOV        R2, R27
	CALL       _Lcd_Chr+0
;TEA5767.c,85 :: 		}
	JMP        L_Print_FM7
L_Print_FM6:
;TEA5767.c,87 :: 		ch = FM/1000;
	PUSH       R5
	PUSH       R4
	PUSH       R3
	PUSH       R2
	LDI        R20, 232
	LDI        R21, 3
	LDI        R22, 0
	LDI        R23, 0
	MOVW       R16, R2
	MOVW       R18, R4
	CALL       _Div_32x32_S+0
	MOVW       R16, R18
	MOVW       R18, R20
;TEA5767.c,88 :: 		Lcd_Chr(2,4,48+ch);
	SUBI       R16, 208
	MOV        R4, R16
	LDI        R27, 4
	MOV        R3, R27
	LDI        R27, 2
	MOV        R2, R27
	CALL       _Lcd_Chr+0
	POP        R2
	POP        R3
	POP        R4
	POP        R5
;TEA5767.c,89 :: 		ch = (FM / 100 )% 10;
	PUSH       R5
	PUSH       R4
	PUSH       R3
	PUSH       R2
	LDI        R20, 100
	LDI        R21, 0
	LDI        R22, 0
	LDI        R23, 0
	MOVW       R16, R2
	MOVW       R18, R4
	CALL       _Div_32x32_S+0
	MOVW       R16, R18
	MOVW       R18, R20
	LDI        R20, 10
	LDI        R21, 0
	LDI        R22, 0
	LDI        R23, 0
	CALL       _Div_32x32_S+0
	MOVW       R16, R22
	MOVW       R18, R24
;TEA5767.c,90 :: 		Lcd_Chr_CP(48+ch);
	SUBI       R16, 208
	MOV        R2, R16
	CALL       _Lcd_Chr_CP+0
	POP        R2
	POP        R3
	POP        R4
	POP        R5
;TEA5767.c,91 :: 		ch = (FM /10)% 10;
	PUSH       R5
	PUSH       R4
	PUSH       R3
	PUSH       R2
	LDI        R20, 10
	LDI        R21, 0
	LDI        R22, 0
	LDI        R23, 0
	MOVW       R16, R2
	MOVW       R18, R4
	CALL       _Div_32x32_S+0
	MOVW       R16, R18
	MOVW       R18, R20
	LDI        R20, 10
	LDI        R21, 0
	LDI        R22, 0
	LDI        R23, 0
	CALL       _Div_32x32_S+0
	MOVW       R16, R22
	MOVW       R18, R24
;TEA5767.c,92 :: 		Lcd_Chr_CP(48+ch);
	SUBI       R16, 208
	MOV        R2, R16
	CALL       _Lcd_Chr_CP+0
;TEA5767.c,93 :: 		Lcd_Chr(2,7,'.');
	LDI        R27, 46
	MOV        R4, R27
	LDI        R27, 7
	MOV        R3, R27
	LDI        R27, 2
	MOV        R2, R27
	CALL       _Lcd_Chr+0
	POP        R2
	POP        R3
	POP        R4
	POP        R5
;TEA5767.c,94 :: 		ch = FM % 10;
	LDI        R20, 10
	LDI        R21, 0
	LDI        R22, 0
	LDI        R23, 0
	MOVW       R16, R2
	MOVW       R18, R4
	CALL       _Div_32x32_S+0
	MOVW       R16, R22
	MOVW       R18, R24
;TEA5767.c,95 :: 		Lcd_Chr(2,8,48+ch);
	SUBI       R16, 208
	MOV        R4, R16
	LDI        R27, 8
	MOV        R3, R27
	LDI        R27, 2
	MOV        R2, R27
	CALL       _Lcd_Chr+0
;TEA5767.c,96 :: 		}
L_Print_FM7:
;TEA5767.c,97 :: 		Delay_ms(10);
	LDI        R17, 208
	LDI        R16, 202
L_Print_FM8:
	DEC        R16
	BRNE       L_Print_FM8
	DEC        R17
	BRNE       L_Print_FM8
	NOP
;TEA5767.c,98 :: 		}
L_end_Print_FM:
	POP        R5
	POP        R4
	POP        R3
	POP        R2
	RET
; end of _Print_FM

_main:
	LDI        R27, 255
	OUT        SPL+0, R27
	LDI        R27, 0
	OUT        SPL+1, R27

;TEA5767.c,99 :: 		void main() {
;TEA5767.c,100 :: 		set_up();
	PUSH       R2
	PUSH       R3
	PUSH       R4
	PUSH       R5
	PUSH       R6
	CALL       _set_up+0
;TEA5767.c,101 :: 		Write_Frequency(Freq);
	LDS        R2, _Freq+0
	LDS        R3, _Freq+1
	LDS        R4, _Freq+2
	LDS        R5, _Freq+3
	CALL       _Write_Frequency+0
;TEA5767.c,102 :: 		Print_FM(Frec);
	LDS        R2, _Frec+0
	LDS        R3, _Frec+1
	LDS        R4, _Frec+2
	LDS        R5, _Frec+3
	CALL       _Print_FM+0
;TEA5767.c,103 :: 		do {
L_main10:
;TEA5767.c,104 :: 		if (Button(&PINB,0,10,0)) e0=0;     //If the bttton is pushing
	CLR        R6
	LDI        R27, 10
	MOV        R5, R27
	CLR        R4
	LDI        R27, #lo_addr(PINB+0)
	MOV        R2, R27
	LDI        R27, hi_addr(PINB+0)
	MOV        R3, R27
	CALL       _Button+0
	TST        R16
	BRNE       L__main36
	JMP        L_main13
L__main36:
	LDI        R27, 0
	STS        _e0+0, R27
L_main13:
;TEA5767.c,105 :: 		if (e0==0 && Button(&PINB,0,10,1)){ // If the bttton was pushing and after that is free
	LDS        R16, _e0+0
	CPI        R16, 0
	BREQ       L__main37
	JMP        L__main28
L__main37:
	LDI        R27, 1
	MOV        R6, R27
	LDI        R27, 10
	MOV        R5, R27
	CLR        R4
	LDI        R27, #lo_addr(PINB+0)
	MOV        R2, R27
	LDI        R27, hi_addr(PINB+0)
	MOV        R3, R27
	CALL       _Button+0
	TST        R16
	BRNE       L__main38
	JMP        L__main27
L__main38:
L__main26:
;TEA5767.c,106 :: 		Freq=Freq-0.1;          //decrease Frequency.
	LDI        R20, 205
	LDI        R21, 204
	LDI        R22, 204
	LDI        R23, 61
	LDS        R16, _Freq+0
	LDS        R17, _Freq+1
	LDS        R18, _Freq+2
	LDS        R19, _Freq+3
	CALL       _float_fpsub1+0
	STS        _Freq+0, R16
	STS        _Freq+1, R17
	STS        _Freq+2, R18
	STS        _Freq+3, R19
;TEA5767.c,107 :: 		Frec=Frec--;
	LDS        R20, _Frec+0
	LDS        R21, _Frec+1
	LDS        R22, _Frec+2
	LDS        R23, _Frec+3
	SUBI       R20, 1
	SBCI       R21, 0
	SBCI       R22, 0
	SBCI       R23, 0
	STS        _Frec+0, R20
	STS        _Frec+1, R21
	STS        _Frec+2, R22
	STS        _Frec+3, R23
;TEA5767.c,108 :: 		if (Freq<88.0) Freq=108.0;
	LDI        R20, 0
	LDI        R21, 0
	LDI        R22, 176
	LDI        R23, 66
	CALL       _float_op_less+0
	OR         R0, R0
	LDI        R27, 0
	BREQ       L__main39
	LDI        R27, 1
L__main39:
	MOV        R16, R27
	TST        R16
	BRNE       L__main40
	JMP        L_main17
L__main40:
	LDI        R27, 0
	STS        _Freq+0, R27
	STS        _Freq+1, R27
	LDI        R27, 216
	STS        _Freq+2, R27
	LDI        R27, 66
	STS        _Freq+3, R27
L_main17:
;TEA5767.c,109 :: 		if (Frec<880) Freq=1080;
	LDS        R20, _Frec+0
	LDS        R21, _Frec+1
	LDS        R22, _Frec+2
	LDS        R23, _Frec+3
	LDI        R16, 112
	LDI        R17, 3
	LDI        R18, 0
	LDI        R19, 0
	CP         R20, R16
	CPC        R21, R17
	CPC        R22, R18
	CPC        R23, R19
	BRLT       L__main41
	JMP        L_main18
L__main41:
	LDI        R27, 0
	STS        _Freq+0, R27
	STS        _Freq+1, R27
	LDI        R27, 135
	STS        _Freq+2, R27
	LDI        R27, 68
	STS        _Freq+3, R27
L_main18:
;TEA5767.c,110 :: 		Write_Frequency(Freq);
	LDS        R2, _Freq+0
	LDS        R3, _Freq+1
	LDS        R4, _Freq+2
	LDS        R5, _Freq+3
	CALL       _Write_Frequency+0
;TEA5767.c,111 :: 		Print_FM(Frec);
	LDS        R2, _Frec+0
	LDS        R3, _Frec+1
	LDS        R4, _Frec+2
	LDS        R5, _Frec+3
	CALL       _Print_FM+0
;TEA5767.c,112 :: 		e0=1;
	LDI        R27, 1
	STS        _e0+0, R27
;TEA5767.c,105 :: 		if (e0==0 && Button(&PINB,0,10,1)){ // If the bttton was pushing and after that is free
L__main28:
L__main27:
;TEA5767.c,114 :: 		if (Button(&PINB,1,10,0)) e1=0;     //If the bttton is pushing
	CLR        R6
	LDI        R27, 10
	MOV        R5, R27
	LDI        R27, 1
	MOV        R4, R27
	LDI        R27, #lo_addr(PINB+0)
	MOV        R2, R27
	LDI        R27, hi_addr(PINB+0)
	MOV        R3, R27
	CALL       _Button+0
	TST        R16
	BRNE       L__main42
	JMP        L_main19
L__main42:
	LDI        R27, 0
	STS        _e1+0, R27
L_main19:
;TEA5767.c,115 :: 		if (e1==0 && Button(&PINB,1,10,1)){ // If the bttton was pushing and after that is free
	LDS        R16, _e1+0
	CPI        R16, 0
	BREQ       L__main43
	JMP        L__main30
L__main43:
	LDI        R27, 1
	MOV        R6, R27
	LDI        R27, 10
	MOV        R5, R27
	LDI        R27, 1
	MOV        R4, R27
	LDI        R27, #lo_addr(PINB+0)
	MOV        R2, R27
	LDI        R27, hi_addr(PINB+0)
	MOV        R3, R27
	CALL       _Button+0
	TST        R16
	BRNE       L__main44
	JMP        L__main29
L__main44:
L__main25:
;TEA5767.c,116 :: 		Freq=Freq+0.1;                //increase Frequency.
	LDS        R16, _Freq+0
	LDS        R17, _Freq+1
	LDS        R18, _Freq+2
	LDS        R19, _Freq+3
	LDI        R20, 205
	LDI        R21, 204
	LDI        R22, 204
	LDI        R23, 61
	CALL       _float_fpadd1+0
	STS        _Freq+0, R16
	STS        _Freq+1, R17
	STS        _Freq+2, R18
	STS        _Freq+3, R19
;TEA5767.c,117 :: 		Frec=Frec++;
	LDS        R20, _Frec+0
	LDS        R21, _Frec+1
	LDS        R22, _Frec+2
	LDS        R23, _Frec+3
	SUBI       R20, 255
	SBCI       R21, 255
	SBCI       R22, 255
	SBCI       R23, 255
	STS        _Frec+0, R20
	STS        _Frec+1, R21
	STS        _Frec+2, R22
	STS        _Frec+3, R23
;TEA5767.c,118 :: 		if (Freq>108.0) Freq=88.0;
	LDI        R20, 0
	LDI        R21, 0
	LDI        R22, 216
	LDI        R23, 66
	CALL       _float_op_big+0
	OR         R0, R0
	LDI        R27, 0
	BREQ       L__main45
	LDI        R27, 1
L__main45:
	MOV        R16, R27
	TST        R16
	BRNE       L__main46
	JMP        L_main23
L__main46:
	LDI        R27, 0
	STS        _Freq+0, R27
	STS        _Freq+1, R27
	LDI        R27, 176
	STS        _Freq+2, R27
	LDI        R27, 66
	STS        _Freq+3, R27
L_main23:
;TEA5767.c,119 :: 		if (Frec>1080) Frec=880;
	LDS        R20, _Frec+0
	LDS        R21, _Frec+1
	LDS        R22, _Frec+2
	LDS        R23, _Frec+3
	LDI        R16, 56
	LDI        R17, 4
	LDI        R18, 0
	LDI        R19, 0
	CP         R16, R20
	CPC        R17, R21
	CPC        R18, R22
	CPC        R19, R23
	BRLT       L__main47
	JMP        L_main24
L__main47:
	LDI        R27, 112
	STS        _Frec+0, R27
	LDI        R27, 3
	STS        _Frec+1, R27
	LDI        R27, 0
	STS        _Frec+2, R27
	STS        _Frec+3, R27
L_main24:
;TEA5767.c,120 :: 		Write_Frequency(Freq);
	LDS        R2, _Freq+0
	LDS        R3, _Freq+1
	LDS        R4, _Freq+2
	LDS        R5, _Freq+3
	CALL       _Write_Frequency+0
;TEA5767.c,121 :: 		Print_FM(Frec);
	LDS        R2, _Frec+0
	LDS        R3, _Frec+1
	LDS        R4, _Frec+2
	LDS        R5, _Frec+3
	CALL       _Print_FM+0
;TEA5767.c,122 :: 		e1=1;
	LDI        R27, 1
	STS        _e1+0, R27
;TEA5767.c,115 :: 		if (e1==0 && Button(&PINB,1,10,1)){ // If the bttton was pushing and after that is free
L__main30:
L__main29:
;TEA5767.c,124 :: 		} while (1);
	JMP        L_main10
;TEA5767.c,125 :: 		}
L_end_main:
	POP        R6
	POP        R5
	POP        R4
	POP        R3
	POP        R2
L__main_end_loop:
	JMP        L__main_end_loop
; end of _main
